# Generated by Django 2.2.17 on 2021-01-31 16:59

from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        ('accounts', '0001_initial'),
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
    ]

    operations = [
        migrations.CreateModel(
            name='Votation',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('topic', models.CharField(max_length=128)),
                ('description', models.TextField()),
                ('votation_type', models.CharField(choices=[('ranked', 'Ranked Choice'), ('normal', 'Regular Voting')], default='normal', max_length=16)),
                ('start_date', models.DateTimeField(help_text='Must be formatted as YYYY-MM-DD HH:MM')),
                ('end_date', models.DateTimeField(help_text='Must be formatted as YYYY-MM-DD HH:MM')),
                ('groups', models.ManyToManyField(blank=True, related_name='votations', to='accounts.Group')),
                ('voters', models.ManyToManyField(related_name='votations', to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'permissions': (('list_votations', 'List votations'), ('manage_votations', 'Manage votations')),
                'default_permissions': (),
            },
        ),
        migrations.CreateModel(
            name='VotationChoice',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=64)),
                ('votation', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='votations.Votation')),
            ],
            options={
                'ordering': ('name',),
                'default_permissions': (),
            },
        ),
        migrations.CreateModel(
            name='VotationVote',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
            ],
            options={
                'default_permissions': (),
            },
        ),
        migrations.CreateModel(
            name='VotationDecision',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('time_cast', models.DateTimeField(auto_now_add=True)),
                ('rank', models.IntegerField(blank=True, null=True)),
                ('choice', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='votations.VotationChoice')),
                ('votation', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='votations.Votation')),
                ('vote', models.ForeignKey(blank=True, default='', null=True, on_delete=django.db.models.deletion.CASCADE, to='votations.VotationVote')),
            ],
            options={
                'default_permissions': (),
            },
        ),
        migrations.AddField(
            model_name='votation',
            name='winner',
            field=models.OneToOneField(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to='votations.VotationChoice'),
        ),
    ]
